/* Problem URL: https://codeforces.com/contest/2106/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;

        vi elem(n);
        cin >> elem;

        vi pos(n + 1);
        rep(i, n) {
            pos[elem[i]] = i;
        }

        while (q--) {
            int l, r, x;
            cin >> l >> r >> x;
            l--, r--;

            if (pos[x] > r || pos[x] < l) {
                cout << "-1 ";
                continue;
            }

            int greater = n - x;
            int lesser = x - 1;
            int cgreater = 0;
            int clesser = 0;
            int ans = 0;
            
            int low = l;
            int high = r;

            bool valid = true;

            while (elem[(low + high) / 2] != x) {
                int mid = (low + high) / 2;

                if (elem[mid] > x) {
                    if (pos[x] > mid) {
                        if (clesser) {
                            clesser--;
                            low = mid + 1;
                            continue;
                        }

                        if (greater == 0 || lesser == 0) {
                            valid = false;
                            break;
                        }

                        lesser--;
                        greater--;
                        cgreater++;
                        ans += 2;

                        low = mid + 1;
                        continue;
                    }

                    if (greater == 0) {
                        valid = false;
                        break;
                    }

                    greater--;
                    high = mid - 1;
                    continue;
                }

                if (pos[x] < mid) {
                    if (cgreater) {
                        cgreater--;
                        high = mid - 1;
                        continue;
                    }

                    if (greater == 0 || lesser == 0) {
                        valid = false;
                        break;
                    }

                    greater--;
                    lesser--;
                    clesser++;
                    ans += 2;

                    high = mid - 1;
                    continue;
                }

                if (lesser == 0) {
                    valid = false;
                    break;
                }

                lesser--;
                low = mid + 1;
            }

            cout << (valid ? ans : -1) << ' ';
        }
        cout << '\n';
    }
}
